package org.dromara.elevator.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.SpringUtils;
import org.dromara.common.core.utils.ValidatorUtils;
import org.dromara.common.excel.core.ExcelListener;
import org.dromara.common.excel.core.ExcelResult;
import org.dromara.elevator.domain.bo.ETenementInfoBo;
import org.dromara.elevator.domain.vo.ETenementInfoImportVo;
import org.dromara.elevator.domain.vo.ETenementInfoVo;
import org.dromara.elevator.service.IETenementInfoService;

import java.util.List;

/**
 * 导入物业单位基础信息
 *
 * @author zy
 */
@Slf4j
public class ETenementInfoImportListener extends AnalysisEventListener<ETenementInfoImportVo> implements ExcelListener<ETenementInfoImportVo> {

    private final IETenementInfoService tenementInfoService;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ETenementInfoImportListener(Boolean isUpdateSupport) {
        this.tenementInfoService = SpringUtils.getBean(IETenementInfoService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(ETenementInfoImportVo tenement, AnalysisContext context) {

        ETenementInfoVo tenementInfo = this.tenementInfoService.selectByCode(tenement.getCode());
        try {
            // 验证是否存在这个用户
            if (ObjectUtil.isNull(tenementInfo)) {
                ETenementInfoBo tenementBo = BeanUtil.toBean(tenement, ETenementInfoBo.class);
                ValidatorUtils.validate(tenementBo);
                tenementInfoService.insertByBo(tenementBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、物业单位 ").append(tenementBo.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long tenementId = tenementInfo.getId();
                ETenementInfoBo tenementInfoBo = BeanUtil.toBean(tenement, ETenementInfoBo.class);
                tenementInfoBo.setId(tenementId);
                ValidatorUtils.validate(tenementInfoBo);
                tenementInfoService.updateByBo(tenementInfoBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、物业单位 ").append(tenement.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、物业单位 ").append(tenement.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、物业单位 " + tenement.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ETenementInfoImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ETenementInfoImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
